// Code generated by SQLBoiler 4.6.0 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/randomize"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testProtocolsSets(t *testing.T) {
	t.Parallel()

	query := ProtocolsSets()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testProtocolsSetsDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProtocolsSetsQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := ProtocolsSets().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProtocolsSetsSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := ProtocolsSetSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProtocolsSetsExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := ProtocolsSetExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if ProtocolsSet exists: %s", err)
	}
	if !e {
		t.Errorf("Expected ProtocolsSetExists to return true, but got false.")
	}
}

func testProtocolsSetsFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	protocolsSetFound, err := FindProtocolsSet(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if protocolsSetFound == nil {
		t.Error("want a record, got nil")
	}
}

func testProtocolsSetsBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = ProtocolsSets().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testProtocolsSetsOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := ProtocolsSets().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testProtocolsSetsAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	protocolsSetOne := &ProtocolsSet{}
	protocolsSetTwo := &ProtocolsSet{}
	if err = randomize.Struct(seed, protocolsSetOne, protocolsSetDBTypes, false, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}
	if err = randomize.Struct(seed, protocolsSetTwo, protocolsSetDBTypes, false, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = protocolsSetOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = protocolsSetTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := ProtocolsSets().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testProtocolsSetsCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	protocolsSetOne := &ProtocolsSet{}
	protocolsSetTwo := &ProtocolsSet{}
	if err = randomize.Struct(seed, protocolsSetOne, protocolsSetDBTypes, false, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}
	if err = randomize.Struct(seed, protocolsSetTwo, protocolsSetDBTypes, false, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = protocolsSetOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = protocolsSetTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func protocolsSetBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func protocolsSetAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *ProtocolsSet) error {
	*o = ProtocolsSet{}
	return nil
}

func testProtocolsSetsHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &ProtocolsSet{}
	o := &ProtocolsSet{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, false); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet object: %s", err)
	}

	AddProtocolsSetHook(boil.BeforeInsertHook, protocolsSetBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	protocolsSetBeforeInsertHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.AfterInsertHook, protocolsSetAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	protocolsSetAfterInsertHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.AfterSelectHook, protocolsSetAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	protocolsSetAfterSelectHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.BeforeUpdateHook, protocolsSetBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	protocolsSetBeforeUpdateHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.AfterUpdateHook, protocolsSetAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	protocolsSetAfterUpdateHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.BeforeDeleteHook, protocolsSetBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	protocolsSetBeforeDeleteHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.AfterDeleteHook, protocolsSetAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	protocolsSetAfterDeleteHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.BeforeUpsertHook, protocolsSetBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	protocolsSetBeforeUpsertHooks = []ProtocolsSetHook{}

	AddProtocolsSetHook(boil.AfterUpsertHook, protocolsSetAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	protocolsSetAfterUpsertHooks = []ProtocolsSetHook{}
}

func testProtocolsSetsInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testProtocolsSetsInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(protocolsSetColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testProtocolsSetToManyPeers(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c Peer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, peerDBTypes, false, peerColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, peerDBTypes, false, peerColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&b.ProtocolsSetID, a.ID)
	queries.Assign(&c.ProtocolsSetID, a.ID)
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.Peers().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if queries.Equal(v.ProtocolsSetID, b.ProtocolsSetID) {
			bFound = true
		}
		if queries.Equal(v.ProtocolsSetID, c.ProtocolsSetID) {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := ProtocolsSetSlice{&a}
	if err = a.L.LoadPeers(ctx, tx, false, (*[]*ProtocolsSet)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Peers); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.Peers = nil
	if err = a.L.LoadPeers(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Peers); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testProtocolsSetToManyVisits(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c Visit

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, visitDBTypes, false, visitColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	queries.Assign(&b.ProtocolsSetID, a.ID)
	queries.Assign(&c.ProtocolsSetID, a.ID)
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.Visits().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if queries.Equal(v.ProtocolsSetID, b.ProtocolsSetID) {
			bFound = true
		}
		if queries.Equal(v.ProtocolsSetID, c.ProtocolsSetID) {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := ProtocolsSetSlice{&a}
	if err = a.L.LoadVisits(ctx, tx, false, (*[]*ProtocolsSet)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Visits); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.Visits = nil
	if err = a.L.LoadVisits(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.Visits); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testProtocolsSetToManyAddOpPeers(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Peer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Peer{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, peerDBTypes, false, strmangle.SetComplement(peerPrimaryKeyColumns, peerColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*Peer{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddPeers(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if !queries.Equal(a.ID, first.ProtocolsSetID) {
			t.Error("foreign key was wrong value", a.ID, first.ProtocolsSetID)
		}
		if !queries.Equal(a.ID, second.ProtocolsSetID) {
			t.Error("foreign key was wrong value", a.ID, second.ProtocolsSetID)
		}

		if first.R.ProtocolsSet != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.ProtocolsSet != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.Peers[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.Peers[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.Peers().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}

func testProtocolsSetToManySetOpPeers(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Peer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Peer{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, peerDBTypes, false, strmangle.SetComplement(peerPrimaryKeyColumns, peerColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	err = a.SetPeers(ctx, tx, false, &b, &c)
	if err != nil {
		t.Fatal(err)
	}

	count, err := a.Peers().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	err = a.SetPeers(ctx, tx, true, &d, &e)
	if err != nil {
		t.Fatal(err)
	}

	count, err = a.Peers().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	if !queries.IsValuerNil(b.ProtocolsSetID) {
		t.Error("want b's foreign key value to be nil")
	}
	if !queries.IsValuerNil(c.ProtocolsSetID) {
		t.Error("want c's foreign key value to be nil")
	}
	if !queries.Equal(a.ID, d.ProtocolsSetID) {
		t.Error("foreign key was wrong value", a.ID, d.ProtocolsSetID)
	}
	if !queries.Equal(a.ID, e.ProtocolsSetID) {
		t.Error("foreign key was wrong value", a.ID, e.ProtocolsSetID)
	}

	if b.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if c.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if d.R.ProtocolsSet != &a {
		t.Error("relationship was not added properly to the foreign struct")
	}
	if e.R.ProtocolsSet != &a {
		t.Error("relationship was not added properly to the foreign struct")
	}

	if a.R.Peers[0] != &d {
		t.Error("relationship struct slice not set to correct value")
	}
	if a.R.Peers[1] != &e {
		t.Error("relationship struct slice not set to correct value")
	}
}

func testProtocolsSetToManyRemoveOpPeers(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Peer

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Peer{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, peerDBTypes, false, strmangle.SetComplement(peerPrimaryKeyColumns, peerColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	err = a.AddPeers(ctx, tx, true, foreigners...)
	if err != nil {
		t.Fatal(err)
	}

	count, err := a.Peers().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 4 {
		t.Error("count was wrong:", count)
	}

	err = a.RemovePeers(ctx, tx, foreigners[:2]...)
	if err != nil {
		t.Fatal(err)
	}

	count, err = a.Peers().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	if !queries.IsValuerNil(b.ProtocolsSetID) {
		t.Error("want b's foreign key value to be nil")
	}
	if !queries.IsValuerNil(c.ProtocolsSetID) {
		t.Error("want c's foreign key value to be nil")
	}

	if b.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if c.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if d.R.ProtocolsSet != &a {
		t.Error("relationship to a should have been preserved")
	}
	if e.R.ProtocolsSet != &a {
		t.Error("relationship to a should have been preserved")
	}

	if len(a.R.Peers) != 2 {
		t.Error("should have preserved two relationships")
	}

	// Removal doesn't do a stable deletion for performance so we have to flip the order
	if a.R.Peers[1] != &d {
		t.Error("relationship to d should have been preserved")
	}
	if a.R.Peers[0] != &e {
		t.Error("relationship to e should have been preserved")
	}
}

func testProtocolsSetToManyAddOpVisits(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Visit

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Visit{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*Visit{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddVisits(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if !queries.Equal(a.ID, first.ProtocolsSetID) {
			t.Error("foreign key was wrong value", a.ID, first.ProtocolsSetID)
		}
		if !queries.Equal(a.ID, second.ProtocolsSetID) {
			t.Error("foreign key was wrong value", a.ID, second.ProtocolsSetID)
		}

		if first.R.ProtocolsSet != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.ProtocolsSet != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.Visits[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.Visits[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.Visits().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}

func testProtocolsSetToManySetOpVisits(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Visit

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Visit{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err = a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	err = a.SetVisits(ctx, tx, false, &b, &c)
	if err != nil {
		t.Fatal(err)
	}

	count, err := a.Visits().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	err = a.SetVisits(ctx, tx, true, &d, &e)
	if err != nil {
		t.Fatal(err)
	}

	count, err = a.Visits().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	if !queries.IsValuerNil(b.ProtocolsSetID) {
		t.Error("want b's foreign key value to be nil")
	}
	if !queries.IsValuerNil(c.ProtocolsSetID) {
		t.Error("want c's foreign key value to be nil")
	}
	if !queries.Equal(a.ID, d.ProtocolsSetID) {
		t.Error("foreign key was wrong value", a.ID, d.ProtocolsSetID)
	}
	if !queries.Equal(a.ID, e.ProtocolsSetID) {
		t.Error("foreign key was wrong value", a.ID, e.ProtocolsSetID)
	}

	if b.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if c.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if d.R.ProtocolsSet != &a {
		t.Error("relationship was not added properly to the foreign struct")
	}
	if e.R.ProtocolsSet != &a {
		t.Error("relationship was not added properly to the foreign struct")
	}

	if a.R.Visits[0] != &d {
		t.Error("relationship struct slice not set to correct value")
	}
	if a.R.Visits[1] != &e {
		t.Error("relationship struct slice not set to correct value")
	}
}

func testProtocolsSetToManyRemoveOpVisits(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProtocolsSet
	var b, c, d, e Visit

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, protocolsSetDBTypes, false, strmangle.SetComplement(protocolsSetPrimaryKeyColumns, protocolsSetColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*Visit{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, visitDBTypes, false, strmangle.SetComplement(visitPrimaryKeyColumns, visitColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	err = a.AddVisits(ctx, tx, true, foreigners...)
	if err != nil {
		t.Fatal(err)
	}

	count, err := a.Visits().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 4 {
		t.Error("count was wrong:", count)
	}

	err = a.RemoveVisits(ctx, tx, foreigners[:2]...)
	if err != nil {
		t.Fatal(err)
	}

	count, err = a.Visits().Count(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}
	if count != 2 {
		t.Error("count was wrong:", count)
	}

	if !queries.IsValuerNil(b.ProtocolsSetID) {
		t.Error("want b's foreign key value to be nil")
	}
	if !queries.IsValuerNil(c.ProtocolsSetID) {
		t.Error("want c's foreign key value to be nil")
	}

	if b.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if c.R.ProtocolsSet != nil {
		t.Error("relationship was not removed properly from the foreign struct")
	}
	if d.R.ProtocolsSet != &a {
		t.Error("relationship to a should have been preserved")
	}
	if e.R.ProtocolsSet != &a {
		t.Error("relationship to a should have been preserved")
	}

	if len(a.R.Visits) != 2 {
		t.Error("should have preserved two relationships")
	}

	// Removal doesn't do a stable deletion for performance so we have to flip the order
	if a.R.Visits[1] != &d {
		t.Error("relationship to d should have been preserved")
	}
	if a.R.Visits[0] != &e {
		t.Error("relationship to e should have been preserved")
	}
}

func testProtocolsSetsReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testProtocolsSetsReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := ProtocolsSetSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testProtocolsSetsSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := ProtocolsSets().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	protocolsSetDBTypes = map[string]string{`ID`: `integer`, `ProtocolIds`: `ARRAYinteger`}
	_                   = bytes.MinRead
)

func testProtocolsSetsUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(protocolsSetPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(protocolsSetAllColumns) == len(protocolsSetPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testProtocolsSetsSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(protocolsSetAllColumns) == len(protocolsSetPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &ProtocolsSet{}
	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, protocolsSetDBTypes, true, protocolsSetPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(protocolsSetAllColumns, protocolsSetPrimaryKeyColumns) {
		fields = protocolsSetAllColumns
	} else {
		fields = strmangle.SetComplement(
			protocolsSetAllColumns,
			protocolsSetPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := ProtocolsSetSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testProtocolsSetsUpsert(t *testing.T) {
	t.Parallel()

	if len(protocolsSetAllColumns) == len(protocolsSetPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := ProtocolsSet{}
	if err = randomize.Struct(seed, &o, protocolsSetDBTypes, true); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert ProtocolsSet: %s", err)
	}

	count, err := ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, protocolsSetDBTypes, false, protocolsSetPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProtocolsSet struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert ProtocolsSet: %s", err)
	}

	count, err = ProtocolsSets().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
